package com.weapes;

import org.springframework.context.annotation.Configuration;
import org.springframework.security.config.annotation.web.builders.HttpSecurity;
import org.springframework.security.config.annotation.web.configuration.EnableWebSecurity;
import org.springframework.security.config.annotation.web.configuration.WebSecurityConfigurerAdapter;

@Configuration
@EnableWebSecurity
public class SecurityConfig extends WebSecurityConfigurerAdapter {

    @Override
    protected void configure(HttpSecurity http) throws Exception {
        http
                .csrf().disable()
                .authorizeRequests()
                .antMatchers("/**").permitAll()
                .antMatchers("/captcha").permitAll()
                .antMatchers("/login").permitAll()
                .antMatchers("/top").permitAll()
                .antMatchers("/paper_detail").permitAll()
                .antMatchers("/logs/*").permitAll()
                .antMatchers("/config/*").permitAll()
                .anyRequest().authenticated();
    }

}
